// New way of doing it
const setHtmlContent = (function(MessageBodyJSNativeInterface) {
    // Calling from Native Layer
    function setHtmlContent(
        htmlBody,
        classId,
        blockImages,
        showMoreText,
        showLessText,
        showImagesText
    ) {
        if (classId != "null") {
            htmlBody = htmlBody.replace(classId, classId + " " + "yQTDBase");
        }

        var messageReadContentDiv = document.getElementById("message_read_content");
        messageReadContentDiv.innerHTML = htmlBody;
        console.log('js: setHtmlContent Filling in data is complete: classId: ' + classId);
        if (classId != "null") {
            // Show More content is available.  So, add the Show More button to the DOM.
            addShowMoreButton(showMoreText, showLessText);
        }
        if (blockImages == "true") {
            messageReadContentDiv.classList.add('image-boxes');
            addShowImagesButton(showImagesText);
        }
    }

    function addShowImagesButton(showImagesText) {
        var showImagesBtn = document.getElementById('show_images_button');
        showImagesBtn.style.display = "block";
        showImagesBtn.textContent = showImagesText;
        // Add a click event listener to the showImagesButton
        showImagesBtn.onclick = function() {
            showImagesBtn.style.display = "none";
            removeImageBoxes();
        }

    }

    // Function to remove the image-boxes class on inner divs of message_read_content
    function removeImageBoxes() {
        // Get the message_read_content div
        var messageReadContentDiv = document.getElementById('message_read_content');
        messageReadContentDiv.classList.remove('image-boxes');
        MessageBodyJSNativeInterface.showImages();
        console.log('js: imgElements' + messageReadContentDiv);
    }


    /**
     * Creates a the Show More button with styles, onclick handler, and then
     * appends it to the body element.
     */
    function addShowMoreButton(
        showMoreText,
        showLessText
    ) {

        var showMoreBtn = document.getElementById('show_hide_button');
        showMoreBtn.style.display = "block";
        showMoreBtn.textContent = showMoreText;

        /*
         * Click handler for the Show More/Less button.
         */
        showMoreBtn.onclick = function() {
            var messageReadContentDiv = document.getElementById("message_read_content");
            var yQTDBaseNodes = messageReadContentDiv.getElementsByClassName("yQTDBase")

            if (showMoreBtn.textContent === showMoreText) {

                for (var i = 0; i < yQTDBaseNodes.length; i++) {
                    yQTDBaseNodes[i].style.display = "block";
                }

                showMoreBtn.textContent = showLessText;
            } else {
                for (var i = 0; i < yQTDBaseNodes.length; i++) {
                    yQTDBaseNodes[i].style.display = "none";
                }
                showMoreBtn.textContent = showMoreText;
            }
        };
    }

    function handleInlineImageClicks(event) {
        var target = event.target;
        var img = target.closest("img");
        if (img) {
            MessageBodyJSNativeInterface.handleImageClick(img.src);
        }
    }

    function handleHrefClicks(event) {
        var target = event.target,
            anchor = target.closest("a");
        var anchorLink = target.closest('a[href^="#"]');

        if (anchorLink) {
            event.preventDefault();
            var linkId = (anchorLink.getAttribute("href") || "").substring(1);
            if (linkId.length == 0) return;
            var innerText = anchorLink.innerText || '';

            var yivContentId = messageReadContentDiv.querySelector('div[id]:first-child').id;
            var destinationSelector = `[id="${yivContentId}${linkId}"]`;

            var destinationElement = document.querySelector(destinationSelector);
            if (destinationElement != null) {
                const destinationRect = destinationElement.getBoundingClientRect();
                MessageBodyJSNativeInterface.scrollWebView(destinationRect.left, destinationRect.top);
            }
        } else if (anchor) {
            var textContent = anchor.innerText || '';

            // Check alt text in case an image was clicked
            for (let i = 0; i < anchor.childElementCount; i++) {
                if (anchor.children[i].tagName === 'IMG' && anchor.children[i].alt) {
                    textContent = anchor.children[i].alt;
                    break;
                }
            }

            var href = anchor.getAttribute("href");
            if (anchor.onclick == null && href != null) {
                MessageBodyJSNativeInterface.handleLinkClick(href, textContent);
            }
        }
    }

    var messageReadContentDiv = document.getElementById("message_read_content");
    messageReadContentDiv.addEventListener("click", handleHrefClicks);
    messageReadContentDiv.addEventListener("click", handleInlineImageClicks);

    return setHtmlContent;
})(MessageBodyJSNativeInterface);
